# Author:: Mike Evans <mike@urlgonomics.com>
# Copyright:: 2013 Urlgonomics LLC.
# License:: Apache License, Version 2.0
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

module Couchbase
  module Error
    class Base < Exception
      attr_accessor :cas, :error, :inner_exception, :key, :operation, :status

      def to_s
        if inner_exception
          inner_exception.to_s
        else
          super
        end
      end
    end

    class Connect < Base
    end

    class Auth < Base
    end

    class Connect < Base
    end

    class NotFound < Base
    end

    class Invalid < Base
    end

    class KeyExists < Base
    end

    class ValueFormat < Base
    end

    class TemporaryFail < Base
    end

    class NotStored < Base
    end
  end
end
